Package org.apache.sis.metadata.iso.extent

# Class DefaultSpatialTemporalExtent

Object
AbstractMetadata
ModifiableMetadata
ISOMetadata
DefaultTemporalExtent
DefaultSpatialTemporalExtent

All Implemented Interfaces:
  `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`, `SpatialTemporalExtent`, `TemporalExtent`

public class DefaultSpatialTemporalExtent extends DefaultTemporalExtent implements SpatialTemporalExtent
Extent with respect to date/time and spatial boundaries. The following properties are mandatory in a well-formed metadata according ISO 19115:
`EX_SpatialTemporalExtent` `├─extent……………………………………` The date and time for the content of the dataset. `└─spatialExtent…………………` The spatial extent component of composite spatial and temporal extent.

## Limitations

- Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
- Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.

Since:
  0.3
See Also:
  - Serialized Form

Defined in the `sis-metadata` module

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class ModifiableMetadata

  `ModifiableMetadata​.State`

- ## Field Summary

  ### Fields inherited from class ISOMetadata

  `identifiers`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DefaultSpatialTemporalExtent()`
  Constructs an initially empty spatial-temporal extent.
  `DefaultSpatialTemporalExtent(GeographicExtent spatialExtent, VerticalExtent verticalExtent, TemporalExtent extent)`
  Constructs a new spatial-temporal extent initialized to the specified values.
  `DefaultSpatialTemporalExtent(SpatialTemporalExtent object)`
  Constructs a new instance initialized with the values from the specified metadata object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DefaultSpatialTemporalExtent`
  `castOrCopy(SpatialTemporalExtent object)`
  Returns a SIS metadata implementation with the values of the given arbitrary implementation.
  `Collection<GeographicExtent>`
  `getSpatialExtent()`
  Returns the spatial extent component of composite spatial and temporal extent.
  `VerticalExtent`
  `getVerticalExtent()`
  Returns the vertical extent component.
  `void`
  `setBounds(Envelope envelope)`
  Sets this spatiotemporal extent to values inferred from the specified envelope.
  `void`
  `setSpatialExtent(Collection<? extends GeographicExtent> newValues)`
  Sets the spatial extent component of composite spatial and temporal extent.
  `void`
  `setVerticalExtent(VerticalExtent newValue)`
  Sets the vertical extent component.

  ### Methods inherited from class DefaultTemporalExtent

  `castOrCopy, getEndTime, getExtent, getStartTime, intersect, setBounds, setExtent`

  ### Methods inherited from class ISOMetadata

  `getIdentifier, getIdentifierMap, getIdentifiers, getStandard, setIdentifier, transitionTo`

  ### Methods inherited from class ModifiableMetadata

  `checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, deepCopy, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, writeCollection, writeList, writeMap, writeSet`

  ### Methods inherited from class AbstractMetadata

  `asMap, asTreeTable, equals, equals, getInterface, hashCode, isEmpty, prune, toString`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface TemporalExtent

  `getExtent`

- ## Constructor Details

  - ### DefaultSpatialTemporalExtent

    public DefaultSpatialTemporalExtent()
    Constructs an initially empty spatial-temporal extent.

  - ### DefaultSpatialTemporalExtent

    public DefaultSpatialTemporalExtent(GeographicExtent spatialExtent, VerticalExtent verticalExtent, TemporalExtent extent)
    Constructs a new spatial-temporal extent initialized to the specified values.
    Parameters:
      `spatialExtent` - the spatial extent component of composite spatial and temporal extent.
      `verticalExtent` - the vertical extent component, or `null` if none.
      `extent` - the date and time for the content of the dataset, or `null` if unspecified.
    Since:
      0.5

  - ### DefaultSpatialTemporalExtent

    public DefaultSpatialTemporalExtent(SpatialTemporalExtent object)
    Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, since the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the metadata to copy values from, or `null` if none.
    See Also:
      - `castOrCopy(SpatialTemporalExtent)`

- ## Method Details

  - ### castOrCopy

    public static DefaultSpatialTemporalExtent castOrCopy(SpatialTemporalExtent object)
    Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
    - If the given object is `null`, then this method returns `null`.
    - Otherwise if the given object is already an instance of `DefaultSpatialTemporalExtent`, then it is returned unchanged.
    - Otherwise a new `DefaultSpatialTemporalExtent` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, since the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the object to get as a SIS implementation, or `null` if none.
    Returns:
      a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

  - ### getSpatialExtent

    public Collection<GeographicExtent> getSpatialExtent()
    Returns the spatial extent component of composite spatial and temporal extent.
    Specified by:
      `getSpatialExtent` in interface `SpatialTemporalExtent`
    Returns:
      the list of geographic extents (never `null`).

  - ### setSpatialExtent

    public void setSpatialExtent(Collection<? extends GeographicExtent> newValues)
    Sets the spatial extent component of composite spatial and temporal extent.
    Parameters:
      `newValues` - the new spatial extent.

  - ### getVerticalExtent

    @UML(identifier="verticalExtent", obligation=OPTIONAL, specification=ISO_19115) public VerticalExtent getVerticalExtent()
    Returns the vertical extent component.
    Returns:
      vertical extent component, or `null` if none.
    Since:
      0.5

  - ### setVerticalExtent

    public void setVerticalExtent(VerticalExtent newValue)
    Sets the vertical extent component.
    Parameters:
      `newValue` - the new vertical extent component.
    Since:
      0.5

  - ### setBounds

    public void setBounds(Envelope envelope) throws TransformException
    Sets this spatiotemporal extent to values inferred from the specified envelope. The given envelope shall have at least a spatial, vertical or temporal component.

    The spatial component is handled as below:

    - If the given envelope has an horizontal component, then:
      - If the collection of spatial extents contains a `GeographicBoundingBox`, then that bounding box will be updated or replaced by a bounding box containing the spatial component of the given envelope.
      - Otherwise a new `DefaultGeographicBoundingBox` with the spatial component of the given envelope is added to the list of spatial extents.
    - All extraneous geographic extents are removed. Non-geographic extents (e.g. descriptions and polygons) are left unchanged.

    Other dimensions are handled in a more straightforward way:

    - The vertical extent is set to the vertical component of the given envelope, or `null` if none.
    - The temporal extent is set to the temporal component of the given envelope, or `null` if none.
    Note: This method is available only if the `sis-referencing` module is available on the classpath.
    Overrides:
      `setBounds` in class `DefaultTemporalExtent`
    Parameters:
      `envelope` - the envelope to use for setting this spatiotemporal extent.
    Throws:
      `UnsupportedOperationException` - if the referencing module is not on the classpath.
      `TransformException` - if the envelope can not be transformed to a temporal extent.
    See Also:
      - `DefaultExtent​.addElements(Envelope)`
      - `DefaultGeographicBoundingBox​.setBounds(Envelope)`
      - `DefaultVerticalExtent​.setBounds(Envelope)`